From 22426607acddee119ce3dacd3fa1b456ed88d4fa Mon Sep 17 00:00:00 2001
From: Nathan Bossart <bossartn@amazon.com>
Date: Thu, 2 May 2019 20:37:45 +0000
Subject: [PATCH v2 1/1] Fix ordering of GRANTs for databases in pg_dump.

---
 src/bin/pg_dump/pg_dumpall.c | 20 ++++++++++++++++----
 1 file changed, 16 insertions(+), 4 deletions(-)

diff --git a/src/bin/pg_dump/pg_dumpall.c b/src/bin/pg_dump/pg_dumpall.c
index 66292354d7..edcc753d95 100644
--- a/src/bin/pg_dump/pg_dumpall.c
+++ b/src/bin/pg_dump/pg_dumpall.c
@@ -1334,11 +1334,23 @@ dumpCreateDB(PGconn *conn)
 						   "pg_encoding_to_char(d.encoding), "
 						   "datcollate, datctype, datfrozenxid, datminmxid, "
 						   "datistemplate, "
-						   "(SELECT pg_catalog.array_agg(acl) FROM (SELECT pg_catalog.unnest(coalesce(datacl,pg_catalog.acldefault('d',datdba))) AS acl "
-						   "EXCEPT SELECT pg_catalog.unnest(pg_catalog.acldefault('d',datdba))) as foo)"
+						   "(SELECT pg_catalog.array_agg(acl ORDER BY row_n) FROM "
+						   "(SELECT acl, row_n FROM "
+						   "pg_catalog.unnest(coalesce(datacl,pg_catalog.acldefault('d',datdba))) "
+						   "WITH ORDINALITY AS perm(acl,row_n) "
+						   "WHERE NOT EXISTS ( "
+						   "SELECT 1 FROM "
+						   "pg_catalog.unnest(pg_catalog.acldefault('d',datdba)) "
+						   "AS init(init_acl) WHERE acl = init_acl)) as datacls) "
 						   "AS datacl, "
-						   "(SELECT pg_catalog.array_agg(acl) FROM (SELECT pg_catalog.unnest(pg_catalog.acldefault('d',datdba)) AS acl "
-						   "EXCEPT SELECT pg_catalog.unnest(coalesce(datacl,pg_catalog.acldefault('d',datdba)))) as foo)"
+						   "(SELECT pg_catalog.array_agg(acl ORDER BY row_n) FROM "
+						   "(SELECT acl, row_n FROM "
+						   "pg_catalog.unnest(pg_catalog.acldefault('d',datdba)) "
+						   "WITH ORDINALITY AS initp(acl,row_n) "
+						   "WHERE NOT EXISTS ( "
+						   "SELECT 1 FROM "
+						   "pg_catalog.unnest(coalesce(datacl,pg_catalog.acldefault('d',datdba))) "
+						   "AS permp(orig_acl) WHERE acl = orig_acl)) as rdatacls) "
 						   "AS rdatacl, "
 						   "datconnlimit, "
 						   "(SELECT spcname FROM pg_tablespace t WHERE t.oid = d.dattablespace) AS dattablespace "
-- 
2.16.5

